--- title: "Create Custom Key" slug: "security-kms2-custom-key" updated: 2026-09-17T10:25:45Z published: 2026-09-17T10:25:45Z canonical: "api.ncloud-docs.com/security-kms2-custom-key" --- > ## Documentation Index > Fetch the complete documentation index at: https://api.ncloud-docs.com/llms.txt > Use this file to discover all available pages before exploring further. # Create Custom Key Available in Classic and VPC Create a randomized raw key that can be utilized as an encryption key. It can only be requested as an AES256 or RSA2048 key type. ## Request This section describes the request format. The method and URI are as follows: | Method | URI | | --- | --- | | POST | /kms/v1/keys/{keyTag}/create-custom-key | ### Request headers For information about the headers common to all Key Management Service APIs, see the account authentication method in [Key Management Service request headers](/docs/en/security-kms#%EC%9A%94%EC%B2%AD%ED%97%A4%EB%8D%942%EA%B3%84%EC%A0%95%EC%9D%B8%EC%A6%9D). ### Request path parameters You can use the following path parameters with your request: | Field | Type | Required | Description | | --- | --- | --- | --- | | `keyTag` | String | Required | Key tag - Unique identifier for the key derived from the key name - See [Get key list](/docs/en/security-kms2-key-list) - Use to request encryption or decryption with REST APIs - Key tags are not treated as confidential information | ### Request body You can include the following data in the body of your request: | Field | Type | Required | Description | | --- | --- | --- | --- | | `requestPlainKey` | Boolean | Optional | Whether to create encrypted random plaintext - `true` \| `false` (default) - `true`: create - `false`: not create | | `bits` | Integer | Optional | Size of the key data to create (bit) - `128` \| `256` (default) \| `512` | | `context` | String | Conditional | Base64-encoded string data - Required when using keys with convergent encryption - Can be up to 50 bytes long - Always generate the same ciphertext, even when encrypting the same data multiple times | ### Request example The request example is as follows: ``` curl --location --request POST 'https://ocapi.ncloud.com/kms/v1/keys/a1b2c3d4e5f6g7h8i9j0k1l2m3n4o5p6q7r8s9t0u1v2w3x4y5z6/create-custom-key' \ --header 'x-ncp-apigw-timestamp: {Timestamp}' \ --header 'x-ncp-iam-access-key: {Access Key}' \ --header 'x-ncp-apigw-signature-v2: {API Gateway Signature}' \ --data '{ "requestPlainKey": true, "bits": 256, "context": "{BASE64_CONTEXT}" }' ``` ## Response This section describes the response format. ### Response body The response body includes the following data: | Field | Type | Required | Description | | --- | --- | --- | --- | | `code` | String | - | Success or Failure | | `data` | Object | - | Response result | | `data.plaintext` | String or Array[String] | - | Base64-encoded random string data | | `data.ciphertext` | String | - | String data created by encrypting a random plaintext | | `data.key_version` | Integer | - | Version of the created custom key | ### Response status codes For information about the HTTP status codes common to all Key Management Service APIs, see [Key Management Service response status codes](/docs/en/security-kms#%EC%9D%91%EB%8B%B5%EC%83%81%ED%83%9C%EC%BD%94%EB%93%9C2). ### Response example The response example is as follows: ``` { "code": "SUCCESS", "data": { "plaintext": "{BASE64_PLAINTEXT}", "ciphertext": "{CIPHERTEXT}", "key_version": 1 } } ```